<template lang="pug">
	section
		h1 Tasks
		Task(
			v-for="task in tasks"
			:key="task.id"
			:id="task.id || task.temp_id"
			:title="task.title"
			:description="task.description"
			:completed="task.completed"
		)
		Icon-button(title="Add new task" type="ghost" name="playlist_add" align="right" @click.native="open_create_dialog")
		Dialog(title="Create task" :onclose="close_create_dialog" :open="create_dialog_open")
			template(slot="content")
				Field-input(placeholder="Title" v-model="new_task.title")
				Field-input(placeholder="Description" v-model="new_task.description")
			template(slot="actions")
				Button(title="Create task" @click.native="create_task" align="right") Create
				Button(title="Close" type="accent" @click.native="close_create_dialog" align="right") Close

</template>

<script lang="ts">
import Vue from 'vue';

import TaskComponent from '@/components/task';
import Icon_button from '@/components/icon_button.vue';
import Field_input from '@/components/field_input.vue';
import Checkbox_input from '@/components/checkbox_input.vue';
import Dialog from '@/components/dialog';
import Button from '@/components/button';
import { Task } from '../types/vuex-task';

export default Vue.extend({
	components: {
		'Task': TaskComponent,
		'Icon-button': Icon_button,
		'Checkbox-input': Checkbox_input,
		'Field-input': Field_input,
		Dialog,
		Button,
	},
	data() {
		return {
			create_dialog_open: false,
			new_task: {
				title: null,
				description: null,
			},
		};
	},
	beforeCreate() {
		this.$store.dispatch('sync_tasks');
	},
	computed: {
		tasks(this: any): Task[] {
			return this.$store.getters.all_tasks || [];
		},
	},
	methods: {
		open_create_dialog(this: any) {
			this.create_dialog_open = true;
		},
		close_create_dialog(this: any) {
			this.create_dialog_open = false;
		},
		create_task(this: any) {
			this.$store.dispatch('create_task', {
				title: this.new_task.title,
				description: this.new_task.description,
				completed: false,
			});
			this.new_task = {
				title: null,
				description: null,
			};
			this.close_create_dialog();
		},
	},
});
</script>
